module  precision
  implicit none
  !integer,parameter:: p_=kind(1.0)
  integer,parameter:: p_=kind(1.0d0)
end module precision


module constants
  use precision,only:p_
  implicit none
  real(p_),parameter:: pi=3.1415926_p_
  real(p_),parameter:: twopi=pi*2.0_p_
  real(p_),parameter:: fourpi=pi*4.0_p_
  real(p_),parameter:: zero=0.0_p_
  real(p_),parameter:: one=1.0_p_
  real(p_),parameter:: two=2.0_p_
  real(p_),parameter:: three=3.0_p_
  real(p_),parameter:: four=4.0_p_
  real(p_),parameter:: five=5.0_p_
  real(p_),parameter:: six=6.0_p_
  real(p_),parameter:: seven=7.0_p_
  real(p_),parameter:: eight=8.0_p_
  real(p_),parameter:: nine=9.0_p_
  real(p_),parameter:: ten=10.0_p_
  real(p_),parameter:: eleven=11.0_p_
  real(p_),parameter:: twelve=12.0_p_
  real(p_),parameter:: thirteen=13.0_p_
  real(p_),parameter:: fourteen=14.0_p_
  real(p_),parameter:: fifteen=15.0_p_

  real(p_),parameter:: one_half=0.5_p_
  real(p_),parameter:: one_third=one/three
  real(p_),parameter:: one_fifth=0.2_p_
  real(p_),parameter:: three_halfs=1.5_p_
end module constants


!!$module particles
!!$  use precision,only:p_
!!$  implicit none
!!$  !integer,parameter::total_number=400000
!!$  !real(p_):: particle_weight(total_number),total_weight
!!$  !real(p_):: g(total_number),total_g
!!$end module particles

module spatial_grids !for solving possion equation
  use precision,only:p_
  implicit none
 integer::ngrids
 real(p_),dimension(:),allocatable:: x,phi,efield,rho !charge density
!  real(p_),parameter:: width=100._p_ !in unit of Debye length
  real(p_)::width!in unit of Debye length
!  real(p_),parameter:: dx=width/(ngrids-1)
!  real(p_):: dx=width/ngrids !this is correct
  real(p_):: dx 
 ! real(p_),parameter:: xmin=0._p_, xmax=width
 real(p_):: xmin, xmax

end module spatial_grids


module velocity_space
  use precision,only:p_
  implicit none
  !two-stream Maxwellian distribution (reduces to Maxwellian distribution when ymean1=ymean2=0)
  real(p_),parameter:: vt=1._p_ !vt is normalized to 1, i.e., vt is used as the velocity unit
  real(p_),parameter:: vb=0._p_ !in unit of vt
  real(p_),parameter:: vb1=-vb,vb2=vb !ymean is the avearay value of Gauss distribution
  real(p_),parameter:: vmin=vb1-3.5_p_*vt
  real(p_),parameter:: vmax=vb2+3.5_p_*vt
end module velocity_space
